
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>

#include <fstream>
#include <iostream>
#include <sstream>
#include <string>

#include "player.h"
#include "font.h"
#include "display.h"
#include "level.h"
#include "explore.h"
#include "misc.h"
#include "encounter.h"

using std::ofstream;
using namespace std;

monster Monsters[47];
monster opponent;

extern Player plyr;
extern sf::RenderWindow App;
sf::Music encounterMusic;

sf::Image encImageSheet;
sf::Sprite encImage;

/*
struct encounter
{
       string name;
       int x;
       int y;
       int z;
	   int removeCursesCost;
};


encounter encounters[12] =
{
	{"Thieves encounter",			44,	30,	0,	9000},
	{"Blue Wizards encounter",		19,	17,	0,	3000},
	{"Light Wizards encounter",		3,	60,	0,	2700},
	{"Green Wizards Academy",	12,	22,	0,	3000},
	{"Red Wizards University",	48,	50,	0,	3000},
	{"Dark Wizards encounter",		34,	43,	0,	3100},
	{"Star Wizards encounter",		28,	53,	0,	2000},
	{"Wizards of Chaos encounter",	51,	5,	0,	4000},
	{"Wizards of Law encounter",	62,	15,	0,	3800},
	{"encounter of Order",			58,	15,	0,	4000},
	{"Physicians encounter",		6,	50,	0,	7000},
	{"Assassins encounter",			56,	62,	0,	11000}
};

*/



inline std::string concat( int n, const char* str )
{
std::ostringstream ss;
ss << n;
ss << str;
return ss.str();
} 

/*
string itos(int i)	// convert int to string
{
	stringstream s;
	s << i;
	return s.str();
}
*/


void updateEncounter()
{	
	encImageSheet.LoadFromFile("data/images/cityEncounterImages.png");
	encImageSheet.CreateMaskFromColor(sf::Color(0, 0, 0));
	encImageSheet.SetSmooth(false);
	string str,key;
	int encounterMenu = 1; // high level menu
	plyr.status = 3; // encounter!
	bool encounterStarted = false;
	encounterMusic.OpenFromFile("data/audio/cityEncounter1.ogg");
	int flashCount = 0;
	bool flashTextOn = true;

	while (encounterMenu > 0)
	{	
		int randomenc = sf::Randomizer::Random(0, 46); // pick random encounter
		int encAnimation = 1;
		while (encounterMenu == 1) // main menu
		{
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			drawCompass();
			drawStatsPanel();
			buildLevelView();

			// Alternate and set animation frame as required
			encImage.SetImage(encImageSheet);
			encImage.SetPosition(310, 176);
			if (Monsters[randomenc].image2==0) { SetTileImage(Monsters[randomenc].image); }
			if (Monsters[randomenc].image2!=0) 
			{
				if (encAnimation==1) { SetTileImage(Monsters[randomenc].image); }
				if (encAnimation==2) { SetTileImage(Monsters[randomenc].image2); }
				
				if ( flashCount==40)
				{	
					if (encAnimation==1) { encAnimation=2; }
					else { encAnimation=1; }
				}
			}
			App.Draw(encImage);
			

			flashCount++;
			if ((flashCount==20) && (!flashTextOn)) { flashTextOn = true; flashCount = 0; }
			if ((flashCount==60) && (flashTextOn)) { flashTextOn = false; flashCount = 0; }
			SetFontColour(111, 159, 6, 255);
			
			// Draw status line text
			string text;
			if ( (Monsters[randomenc].name.substr (0,1)=="A") ||
				(Monsters[randomenc].name.substr (0,1)=="O") ||
				(Monsters[randomenc].name.substr (0,1)=="I")) 
				{text = "You encounter an "+Monsters[randomenc].name;}
			else { text = "You encounter a "+Monsters[randomenc].name; }
			drawText(2,6,text);
			
			// Draw high level encounter menu
			SetFontColour(255, 255, 255, 255);
			cyText (2, "Encounter Options");
			if (flashTextOn)
			{
				bText (5,4, "(1) Attack");
				bText (5,5, "(2) Charge");
				bText (5,6, "(3) Aimed Attack");
				bText (5,7, "(4) Switch weapon");
				bText (5,8, "(5) Charm");
				bText (5,9, "(0) Leave");
				bText (24,4, "(6) Trick");
				bText (24,5, "(7) Cast spell");
				bText (24,6, "(8) Use items");
				bText (24,7, "(9) Hail");
				bText (24,8, "(A) Offer");
			}
			else
			{
				bText (5,4, "( ) Attack");
				bText (5,5, "( ) Charge");
				bText (5,6, "( ) Aimed Attack");
				bText (5,7, "( ) Switch weapon");
				bText (5,8, "( ) Charm");
				bText (5,9, "( ) Leave");
				bText (24,4, "( ) Trick");
				bText (24,5, "( ) Cast spell");
				bText (24,6, "( ) Use items");
				bText (24,7, "( ) Hail");
				bText (24,8, "( ) Offer");
			}
			/*
			std::ostringstream text;
			text << "no is:" << encCheck;		
			cyText (1,text.str());
			text.str("");
			*/

			if (!encounterStarted) { initMonster(randomenc); encounterStarted = true; } // initialise monster attributes
			if (plyr.diagOn) { displayMonsterDiag(); }

			App.Display(); // Refresh screen so drawn items are visible

			// Play encounter music
			/*
			if (!encounterStarted) { encounterMusic.Play(); encounterStarted = true; } // comment out for development
			while (encounterMusic.GetStatus() == sf::Music::Playing)
			{
				// Leave some CPU time for other threads
				sf::Sleep(0.1f);
			}
			*/

			key = getSingleKey();
			if ( key=="0" ) { encounterMenu = 0; }
			if ( key=="1" ) { playerAttack(); }
			if ( key=="2" ) { playerCharge(); }
			if ( key=="3" ) { playerAimedAttack(); }
		}

	}

}

void playerAttack()
{
	bText (2,3, "You attack with your bare hands");
	bText (2,4, "but miss.");
	key = getSingleKey();
	//bText (5,6, "(3) Aimed Attack");
}


void playerCharge()
{

}


void playerAimedAttack()
{

}

void initMonster(int monsterNo)
{
	opponent = Monsters[monsterNo]; // copy monster details to current opponent object
	opponent.baseHP += sf::Randomizer::Random(0,Monsters[monsterNo].randomHP);
	opponent.baseStrength += sf::Randomizer::Random(0,Monsters[monsterNo].randomStrength);
	opponent.baseSkill += sf::Randomizer::Random(0,Monsters[monsterNo].randomSkill);
	opponent.baseIntelligence += sf::Randomizer::Random(0,Monsters[monsterNo].randomIntelligence);
	opponent.baseSpeed += sf::Randomizer::Random(0,Monsters[monsterNo].randomSpeed);
}



void displayMonsterDiag()
{
	drawText(33,8,"HP: ");
	drawText(37,8,opponent.baseHP);
	drawText(33,9,"STR:");
	drawText(37,9,opponent.baseStrength);
	drawText(33,10,"SKL:");
	drawText(37,10,opponent.baseSkill);
	drawText(33,11,"INT:");
	drawText(37,11,opponent.baseIntelligence);
	drawText(33,12,"SPD:");
	drawText(37,12,opponent.baseSpeed);
}















void SetTileImage(int tile_no)
{
	
	int row, column;
	int tilesPerRow = 8; // number of tiles per row in source image containing all tiles (8 default)
	int tilesPerColumn = 8; // number of tiles per column in source image (8 default)
	
	//Select 64x128 section of tile sheet for tile
	
	if ( tile_no > tilesPerRow)
	{
		column = (tile_no % tilesPerRow); // remainder
		row = ((tile_no-column)/tilesPerRow);
	}
	else
	{
		column = tile_no;
		row = 0; // = row 1 on the actual tile sheet at y=0
	}

	int tileX = (column)*64;	// x loc on tiles image in pixels
	int tileY = (row)*128;		// y loc on tiles image in pixels
	encImage.SetSubRect(sf::IntRect(tileX, tileY , (tileX+64), (tileY+128)));
}



void loadCityMonsters()
{

	std::ifstream instream;
	std::string junk,junk2, data;

	instream.open("data\\map\\cityMonsters2.txt");
	if( !instream ) 
	{
      cerr << "Error: City monsters file could not be loaded" << endl;
	}

	for(int i = 0; i < 47; ++i) // number of monsters - test for 2
	{	
		string junk, line, text;
		int monster_attributes = 33; // should be 33
		string::size_type idx;
		getline(instream, junk); // read first line as blank
		for (int a = 0; a < monster_attributes; ++a) // number of attributes - test for 33
		{
			getline(instream, line);
			idx = line.find('=');
			text = line.substr(idx+2);
			//cout << a << ", " << text << "\n";
			if (a==0) { Monsters[i].name = text; }
			if (a==1) { Monsters[i].armorText = text; }
			if (a==2) { Monsters[i].behaviour = atoi(text.c_str()); }
			if (a==3) { Monsters[i].alignment = atoi(text.c_str()); }
			if (a==4) { Monsters[i].stealth = atoi(text.c_str()); }
			if (a==5) { Monsters[i].baseStrength = atoi(text.c_str()); }
			if (a==6) { Monsters[i].randomStrength = atoi(text.c_str()); }
			if (a==7) { Monsters[i].baseSkill = atoi(text.c_str()); }
			if (a==8) { Monsters[i].randomSkill = atoi(text.c_str()); }
			if (a==9) { Monsters[i].baseIntelligence = atoi(text.c_str()); }
			if (a==10) { Monsters[i].randomIntelligence = atoi(text.c_str()); }
			if (a==11) { Monsters[i].baseSpeed = atoi(text.c_str()); }
			if (a==12) { Monsters[i].randomSpeed = atoi(text.c_str()); }
			if (a==13) { Monsters[i].baseHP = atoi(text.c_str()); }
			if (a==14) { Monsters[i].randomHP = atoi(text.c_str()); }
			if (a==15) { Monsters[i].image = atoi(text.c_str()); }
			if (a==16) { Monsters[i].image2 = atoi(text.c_str()); }

			if (a==17) { Monsters[i].armorBlunt = atoi(text.c_str()); }
			if (a==18) { Monsters[i].armorSharp = atoi(text.c_str()); }
			if (a==19) { Monsters[i].armorEarth = atoi(text.c_str()); }
			if (a==20) { Monsters[i].armorAir = atoi(text.c_str()); }
			if (a==21) { Monsters[i].armorFire = atoi(text.c_str()); }
			if (a==22) { Monsters[i].armorWater = atoi(text.c_str()); }
			if (a==23) { Monsters[i].armorPower = atoi(text.c_str()); }
			if (a==24) { Monsters[i].armorMental = atoi(text.c_str()); }
			if (a==25) { Monsters[i].armorCleric = atoi(text.c_str()); }

			if (a==26) { Monsters[i].treasurePotions = atoi(text.c_str()); }
			if (a==27) { Monsters[i].treasureEquipment = atoi(text.c_str()); }
			if (a==28) { Monsters[i].treasureCopper = atoi(text.c_str()); }
			if (a==29) { Monsters[i].treasureSilver = atoi(text.c_str()); }
			if (a==30) { Monsters[i].treasureGold = atoi(text.c_str()); }
			if (a==31) { Monsters[i].treasureGems = atoi(text.c_str()); }
			if (a==32) { Monsters[i].treasureJewels = atoi(text.c_str()); }
		}
		getline(instream, junk);
		//cout << "\n\n";
	}
	instream.close();
}