
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>

#include <string>
#include <iostream>
#include <sstream>

#include "player.h"
#include "font.h"
#include "display.h"
#include "explore.h"
#include "misc.h"
#include "smithy.h"

extern Player plyr;
extern sf::RenderWindow App;
sf::Music smithyMusic;
int itemChoice;
int menuStartItem;
int maxMenuItems = 6;
int smithyNo;

struct Smithy
{
       string name;
       float minimumPriceFactor;
	   float initialPriceFactor;
	   int x;
	   int y;
	   int openingHour;
	   int closingHour;
};

Smithy Smithies[4] =
{
	{"Sharp Weaponsmiths",		1.25,		1.65,	0,		0,		6,	12},
	{"Occum's Weaponsmiths",	1.10,		1.35,	0,		0,		6,	12},
	{"Best Armorers",			1.50,		2.40,	33,		37,		6,	12},
	{"Knight's Armorers",		1.60,		2.35,	0,		0,		6,	12}
	
};


int smithyDailyWares[4][10];

struct smithyItem
{
       string name;
       int basePrice;
};

smithyItem smithyWares[14] =
{
	{"a Tower Shield",	9488},
	{"a War Net",		908},
	{"a Spiked Shield",	6160},
	{"a Shield",		4290},
	{"a Small Shield",	2460},
	{"a Stiletto",		113},
	{"a Dagger",		129},
	{"a Whip",			396},
	{"a Shortsword",	3146},
	{"a Flail",			4620},
	{"a Battle Axe",	6930},
	{"a Sword",			7680},
	{"a Battle Hammer",	10285},
	{"a Longsword",		11193}
	
};




inline std::string concat( int n, const char* str )
{
std::ostringstream ss;
ss << n;
ss << str;
return ss.str();
} 

/*
string itos(int i)	// convert int to string
{
	stringstream s;
	s << i;
	return s.str();
}
*/


void shopSmithy()
{	

	//int smithyNo = getsmithyNo();
	
	bool musicPlaying = false;
	int smithyMenu = 1; // high level menu
	int smithyLoc = 0; // bar, table or booth
	string str,key;
	plyr.status = 2; // shopping
	menuStartItem = 0; // menu starts at item 0

	while (smithyMenu > 0)
	{		
		while (smithyMenu == 1) // main menu
		{
			drawShopImage("imgCitySmithy");
			drawStatsPanel();
			bText (13,0, "Welcome Stranger!");
			bText (7,3, "Do you wish to see our wares?");
			cyText (5, "( es or  o)");
			SetFontColour(40, 96, 244, 255);
			cyText (5, " Y      N  ");
			SetFontColour(255, 255, 255, 255);
			str = "Your coins in copper " + itos(plyr.copper);
			cyText (9,str);
			App.Display();

			if (!musicPlaying) { smithyMusic.OpenFromFile("data/audio/armor.ogg"); smithyMusic.Play(); musicPlaying = true; }

			key = pressKey();
			if ( key=="Y" ) { smithyMenu = 2; }
			if ( key=="N" ) { smithyMenu = 0; }
		}

		while (smithyMenu == 2) 
		{
			drawShopImage("imgCitySmithy");
			drawStatsPanel();
			
			
			cyText (0, "What would you like? (  to leave)");
			SetFontColour(40, 96, 244, 255);
			cyText (0, "                      0          ");
			SetFontColour(255, 255, 255, 255);
			smithyNo = getSmithyNo();
			for (int i=0 ; i<maxMenuItems ; i++)
			{
				int itemNo = smithyDailyWares[smithyNo][menuStartItem+i];
				
				str = ") " + smithyWares[itemNo].name;
				bText(4,(2+i), str);
				bText(1,(2+i), "                               coppers");
			}
			str = "Your coins in copper " + itos(plyr.copper);
			cyText (9,str);

			int itemCost, x;
			for (int i=0 ; i<maxMenuItems ; i++) // Max number of item prices in this menu display
			{
				x = 28;
				int itemNo = smithyDailyWares[smithyNo][menuStartItem+i];
				//itemCost = Smithies[i].initialPriceFactor * smithyWares[itemNo].basePrice;
				itemCost = smithyWares[itemNo].basePrice;
				if (itemCost<100) { x = 29;}
				if (itemCost>999) { x = 27;}
				if (itemCost>9999) { x = 26;}
				bText (x,(i+2),itemCost);
			}

			SetFontColour(40, 96, 244, 255);
			bText (3,2, "1");
			bText (3,3, "2");
			bText (3,4, "3");
			bText (3,5, "4");
			bText (3,6, "5");
			bText (3,7, "6");
			if (menuStartItem!=0) { bText (3,1, "}"); }
			if (menuStartItem!=4) { bText (3,8, "{"); }
			SetFontColour(255, 255, 255, 255);

			App.Display();
			
			key = getSingleKey();
			if ( key=="1" ) { itemChoice = 0; smithyMenu = 3; }
			if ( key=="2" ) { itemChoice = 1; smithyMenu = 3; }
			if ( key=="3" ) { itemChoice = 2; smithyMenu = 3; }
			if ( key=="4" ) { itemChoice = 3; smithyMenu = 3; }
			if ( key=="5" ) { itemChoice = 4; smithyMenu = 3; }
			if ( key=="6" ) { itemChoice = 5; smithyMenu = 3; }
			if ( (key=="up") && (menuStartItem>0) ) { menuStartItem--; }
			if ( (key=="down") && (menuStartItem<4) ) { menuStartItem++; }
			if ( key=="QUIT" ) { smithyMenu = 0; }
			if ( key=="0" ) { smithyMenu = 0; }
			
		}

		while (smithyMenu == 3) // buy item
		{
			smithyNo = getSmithyNo();
			int itemNo = smithyDailyWares[smithyNo][menuStartItem+itemChoice];
			drawShopImage("imgCitySmithy");
			drawStatsPanel();
			
			str = "The cost for " + smithyWares[itemNo].name; 
			cyText (0,str);
			str = "is " + itos(smithyWares[itemNo].basePrice) + " coppers. Agreed?";
			cyText (1,str);
			
			bText (11,3," ) Agree to price");
			bText (11,4," ) Make an offer");
			bText (11,5," ) No sale");
			bText (11,6," ) Leave");
			str = "Your coins in copper " + itos(plyr.copper);
			cyText (9,str);
			SetFontColour(40, 96, 244, 255);
			bText (11,3,"1");
			bText (11,4,"2");
			bText (11,5,"3");
			bText (11,6,"0");
			SetFontColour(255, 255, 255, 255);

			App.Display();

			key = getSingleKey();
			if ( key=="1" ) { smithyMenu = 4; }
			if ( key=="3" ) { smithyMenu = 2; }
			if ( key=="0" ) { smithyMenu = 0; }
		
		}

		while (smithyMenu == 4) // Agree to buy item
		{
			drawShopImage("imgCitySmithy");
			drawStatsPanel();
			
			smithyNo = getSmithyNo();
			int itemNo = smithyDailyWares[smithyNo][menuStartItem+itemChoice];
			int itemCost = smithyWares[itemNo].basePrice;

			if (itemCost > plyr.copper)
			{
				cText ("THAT OFFENDS ME DEEPLY!@Why don't you get serious and only@agree to something that you can afford!");
				cyText (9,"( Press a key )");
				App.Display();
				key = getSingleKey();
				
				if ( key!="" ) { smithyMenu = 2; } // back to purchases
			}
			else
			{
				cText ("I'm sorry, but I am out of stock@for that item.");
				cyText (9,"( Press a key )");
				App.Display();
				key = getSingleKey();
				
				if ( key!="" ) { smithyMenu = 2; } // back to purchases
			}
	
		
		}
		

	}
	smithyMusic.Stop();
	leaveShop();
}


int getSmithyNo()
{
	int smithy_no;
	for (int i=0 ; i<4 ; i++) // Max number of smithy objects
	{
		if ((Smithies[i].x == plyr.x) && (Smithies[i].y == plyr.y))
		{
				smithy_no = i; // The number of the smithy you have entered
		}
	} 
	return smithy_no;
}


void stockSmithyWares()
{
	// Run each hour to randomly pick 10 items for sale at each of the 4 smithies 
	for (int smithyNo=0 ; smithyNo<4 ; smithyNo++)
	{
		for (int waresNo=0 ; waresNo<10 ; waresNo++)
		{
			// Current code may create duplicate items in each smithy
			smithyDailyWares[smithyNo][waresNo] = sf::Randomizer::Random(0,13);
		}
	}

	/*
	int smithyDailyWares[4][10];
	struct smithyItem
	{
		   string name;
		   int basePrice;
	};
	smithyItem smithyWares[14] =
	
	smithyDailyWares[smithyNo][waresNo] = smithyItemNo;
	*/

}